
//Licensed Materials - Property of IBM 
// Copyright IBM Corporation 2006, 2008. All Rights Reserved.

package com.telelogic.rhapsody.core;


 /**
  * The IRPState interface represents states in a statechart.
  */
public interface IRPState  extends IRPStateVertex {
	/**
	 * method addActivityFinal
	 * @throws RhapsodyRuntimeException
	 */
	public IRPState addActivityFinal();
	/**
	 * method addConnector
	 * @throws RhapsodyRuntimeException
	 */
	public IRPConnector addConnector(String type);
	/**
	 * method addState
	 * @throws RhapsodyRuntimeException
	 */
	public IRPState addState(String name);
	/**
	 * method addStaticReaction
	 * @throws RhapsodyRuntimeException
	 */
	public IRPTransition addStaticReaction(IRPInterfaceItem trigger);
	/**
	 * method addTerminationState
	 * @throws RhapsodyRuntimeException
	 */
	public IRPState addTerminationState();
	/**
	 * method createDefaultTransition
	 * @throws RhapsodyRuntimeException
	 */
	public IRPTransition createDefaultTransition(IRPState from);
	/**
	 * method createNestedStatechart
	 * @throws RhapsodyRuntimeException
	 */
	public IRPStatechart createNestedStatechart();
	/**
	 * method deleteConnector
	 * @throws RhapsodyRuntimeException
	 */
	public void deleteConnector(IRPConnector connector);
	/**
	 * method deleteStaticReaction
	 * @throws RhapsodyRuntimeException
	 */
	public void deleteStaticReaction(IRPTransition pVal);
	/**
	 * get property defaultTransition
	 * @throws RhapsodyRuntimeException
	 */
	public IRPTransition getDefaultTransition();
	/**
	 * get property entryAction
	 * @throws RhapsodyRuntimeException
	 */
	public String getEntryAction();
	/**
	 * get property exitAction
	 * @throws RhapsodyRuntimeException
	 */
	public String getExitAction();
	/**
	 * method getFullNameInStatechart
	 * @throws RhapsodyRuntimeException
	 */
	public String getFullNameInStatechart();
	/**
	 * method getInheritsFrom
	 * @throws RhapsodyRuntimeException
	 */
	public IRPState getInheritsFrom();
	/**
	 * get isOverridden
	 * @throws RhapsodyRuntimeException
	 */
	public int getIsOverridden();
	/**
	 * get property isReferenceActivity
	 * @throws RhapsodyRuntimeException
	 */
	public int getIsReferenceActivity();
	/**
	 * get property itsStatechart
	 * @throws RhapsodyRuntimeException
	 */
	public IRPStatechart getItsStatechart();
	/**
	 * get property itsSwimlane
	 * @throws RhapsodyRuntimeException
	 */
	public IRPSwimlane getItsSwimlane();
	/**
	 * method getLogicalStates
	 * @throws RhapsodyRuntimeException
	 */
	public IRPCollection getLogicalStates();
	/**
	 * get property nestedStatechart
	 * @throws RhapsodyRuntimeException
	 */
	public IRPStatechart getNestedStatechart();
	/**
	 * get property referenceToActivity
	 * @throws RhapsodyRuntimeException
	 */
	public IRPModelElement getReferenceToActivity();
	/**
	 * method getSendAction
	 * @throws RhapsodyRuntimeException
	 */
	public IRPSendAction getSendAction();
	/**
	 * get property stateType
	 * @throws RhapsodyRuntimeException
	 */
	public String getStateType();
	/**
	 * method getStaticReactions
	 * @throws RhapsodyRuntimeException
	 */
	public IRPCollection getStaticReactions();
	/**
	 * get property subStateVertices
	 * @throws RhapsodyRuntimeException
	 */
	public IRPCollection getSubStateVertices();
	/**
	 * method getSubStates
	 * @throws RhapsodyRuntimeException
	 */
	public IRPCollection getSubStates();
	/**
	 * method isAnd
	 * @throws RhapsodyRuntimeException
	 */
	public int isAnd();
	/**
	 * method isCompound
	 * @throws RhapsodyRuntimeException
	 */
	public int isCompound();
	/**
	 * method isLeaf
	 * @throws RhapsodyRuntimeException
	 */
	public int isLeaf();
	/**
	 * method isRoot
	 * @throws RhapsodyRuntimeException
	 */
	public int isRoot();
	/**
	 * method isSendActionState
	 * @throws RhapsodyRuntimeException
	 */
	public int isSendActionState();
	/**
	 * method overrideInheritance
	 * @throws RhapsodyRuntimeException
	 */
	public void overrideInheritance();
	/**
	 * method resetEntryActionInheritance
	 * @throws RhapsodyRuntimeException
	 */
	public IRPState resetEntryActionInheritance();
	/**
	 * method resetExitActionInheritance
	 * @throws RhapsodyRuntimeException
	 */
	public IRPState resetExitActionInheritance();
	/**
	 * set property entryAction
	 * @throws RhapsodyRuntimeException
	 */
	public void setEntryAction(String entryAction);
	/**
	 * set property exitAction
	 * @throws RhapsodyRuntimeException
	 */
	public void setExitAction(String exitAction);
	/**
	 * set property itsSwimlane
	 * @throws RhapsodyRuntimeException
	 */
	public void setItsSwimlane(IRPSwimlane itsSwimlane);
	/**
	 * set property referenceToActivity
	 * @throws RhapsodyRuntimeException
	 */
	public void setReferenceToActivity(IRPModelElement referenceToActivity);
	/**
	 * set property stateType
	 * @throws RhapsodyRuntimeException
	 */
	public void setStateType(String stateType);
	/**
	 * method setStaticReaction
	 * @throws RhapsodyRuntimeException
	 */
	public void setStaticReaction(String trigVal, String guardVal, String actionVal);
	/**
	 * method unoverrideInheritance
	 * @throws RhapsodyRuntimeException
	 */
	public void unoverrideInheritance();
}

